/*****************************************************************************
 * modules_builtin.h: built-in modules list
 *****************************************************************************
 * Copyright (C) 2001 VideoLAN
 *
 * Authors: Samuel Hocevar <sam@zoy.org>
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 * 
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111, USA.
 *****************************************************************************/

#define ALLOCATE_BUILTIN( NAME ) \
    AllocateBuiltinModule( InitModule__MODULE_ ## NAME, \
                           ActivateModule__MODULE_ ## NAME, \
                           DeactivateModule__MODULE_ ## NAME );

/* We also consider the main program as a module (useful for config stuff) */
int InitModule__MODULE_main( module_t* );
int ActivateModule__MODULE_main( module_t* );
int DeactivateModule__MODULE_main( module_t* );

/* Add stuff here */
int InitModule__MODULE_idct( module_t* );
int ActivateModule__MODULE_idct( module_t* );
int DeactivateModule__MODULE_idct( module_t* );
int InitModule__MODULE_idctclassic( module_t* );
int ActivateModule__MODULE_idctclassic( module_t* );
int DeactivateModule__MODULE_idctclassic( module_t* );
int InitModule__MODULE_motion( module_t* );
int ActivateModule__MODULE_motion( module_t* );
int DeactivateModule__MODULE_motion( module_t* );
int InitModule__MODULE_imdct( module_t* );
int ActivateModule__MODULE_imdct( module_t* );
int DeactivateModule__MODULE_imdct( module_t* );
int InitModule__MODULE_downmix( module_t* );
int ActivateModule__MODULE_downmix( module_t* );
int DeactivateModule__MODULE_downmix( module_t* );
int InitModule__MODULE_chroma_i420_rgb( module_t* );
int ActivateModule__MODULE_chroma_i420_rgb( module_t* );
int DeactivateModule__MODULE_chroma_i420_rgb( module_t* );
int InitModule__MODULE_chroma_i420_yuy2( module_t* );
int ActivateModule__MODULE_chroma_i420_yuy2( module_t* );
int DeactivateModule__MODULE_chroma_i420_yuy2( module_t* );
int InitModule__MODULE_chroma_i422_yuy2( module_t* );
int ActivateModule__MODULE_chroma_i422_yuy2( module_t* );
int DeactivateModule__MODULE_chroma_i422_yuy2( module_t* );
int InitModule__MODULE_chroma_i420_ymga( module_t* );
int ActivateModule__MODULE_chroma_i420_ymga( module_t* );
int DeactivateModule__MODULE_chroma_i420_ymga( module_t* );
int InitModule__MODULE_mpeg_adec( module_t* );
int ActivateModule__MODULE_mpeg_adec( module_t* );
int DeactivateModule__MODULE_mpeg_adec( module_t* );
int InitModule__MODULE_ac3_adec( module_t* );
int ActivateModule__MODULE_ac3_adec( module_t* );
int DeactivateModule__MODULE_ac3_adec( module_t* );
int InitModule__MODULE_mpeg_vdec( module_t* );
int ActivateModule__MODULE_mpeg_vdec( module_t* );
int DeactivateModule__MODULE_mpeg_vdec( module_t* );
int InitModule__MODULE_memcpymmx( module_t* );
int ActivateModule__MODULE_memcpymmx( module_t* );
int DeactivateModule__MODULE_memcpymmx( module_t* );
int InitModule__MODULE_idctmmx( module_t* );
int ActivateModule__MODULE_idctmmx( module_t* );
int DeactivateModule__MODULE_idctmmx( module_t* );
int InitModule__MODULE_motionmmx( module_t* );
int ActivateModule__MODULE_motionmmx( module_t* );
int DeactivateModule__MODULE_motionmmx( module_t* );
int InitModule__MODULE_chroma_i420_rgb_mmx( module_t* );
int ActivateModule__MODULE_chroma_i420_rgb_mmx( module_t* );
int DeactivateModule__MODULE_chroma_i420_rgb_mmx( module_t* );
int InitModule__MODULE_chroma_i420_yuy2_mmx( module_t* );
int ActivateModule__MODULE_chroma_i420_yuy2_mmx( module_t* );
int DeactivateModule__MODULE_chroma_i420_yuy2_mmx( module_t* );
int InitModule__MODULE_chroma_i422_yuy2_mmx( module_t* );
int ActivateModule__MODULE_chroma_i422_yuy2_mmx( module_t* );
int DeactivateModule__MODULE_chroma_i422_yuy2_mmx( module_t* );
int InitModule__MODULE_chroma_i420_ymga_mmx( module_t* );
int ActivateModule__MODULE_chroma_i420_ymga_mmx( module_t* );
int DeactivateModule__MODULE_chroma_i420_ymga_mmx( module_t* );
int InitModule__MODULE_memcpymmxext( module_t* );
int ActivateModule__MODULE_memcpymmxext( module_t* );
int DeactivateModule__MODULE_memcpymmxext( module_t* );
int InitModule__MODULE_idctmmxext( module_t* );
int ActivateModule__MODULE_idctmmxext( module_t* );
int DeactivateModule__MODULE_idctmmxext( module_t* );
int InitModule__MODULE_motionmmxext( module_t* );
int ActivateModule__MODULE_motionmmxext( module_t* );
int DeactivateModule__MODULE_motionmmxext( module_t* );
int InitModule__MODULE_memcpy3dn( module_t* );
int ActivateModule__MODULE_memcpy3dn( module_t* );
int DeactivateModule__MODULE_memcpy3dn( module_t* );
int InitModule__MODULE_imdct3dn( module_t* );
int ActivateModule__MODULE_imdct3dn( module_t* );
int DeactivateModule__MODULE_imdct3dn( module_t* );
int InitModule__MODULE_downmix3dn( module_t* );
int ActivateModule__MODULE_downmix3dn( module_t* );
int DeactivateModule__MODULE_downmix3dn( module_t* );
int InitModule__MODULE_imdctsse( module_t* );
int ActivateModule__MODULE_imdctsse( module_t* );
int DeactivateModule__MODULE_imdctsse( module_t* );
int InitModule__MODULE_downmixsse( module_t* );
int ActivateModule__MODULE_downmixsse( module_t* );
int DeactivateModule__MODULE_downmixsse( module_t* );
int InitModule__MODULE_ffmpeg( module_t* );
int ActivateModule__MODULE_ffmpeg( module_t* );
int DeactivateModule__MODULE_ffmpeg( module_t* );
int InitModule__MODULE_a52( module_t* );
int ActivateModule__MODULE_a52( module_t* );
int DeactivateModule__MODULE_a52( module_t* );

#define ALLOCATE_ALL_BUILTINS() \
    do \
    { \
        ALLOCATE_BUILTIN(idct); \
        ALLOCATE_BUILTIN(idctclassic); \
        ALLOCATE_BUILTIN(motion); \
        ALLOCATE_BUILTIN(imdct); \
        ALLOCATE_BUILTIN(downmix); \
        ALLOCATE_BUILTIN(chroma_i420_rgb); \
        ALLOCATE_BUILTIN(chroma_i420_yuy2); \
        ALLOCATE_BUILTIN(chroma_i422_yuy2); \
        ALLOCATE_BUILTIN(chroma_i420_ymga); \
        ALLOCATE_BUILTIN(mpeg_adec); \
        ALLOCATE_BUILTIN(ac3_adec); \
        ALLOCATE_BUILTIN(mpeg_vdec); \
        ALLOCATE_BUILTIN(memcpymmx); \
        ALLOCATE_BUILTIN(idctmmx); \
        ALLOCATE_BUILTIN(motionmmx); \
        ALLOCATE_BUILTIN(chroma_i420_rgb_mmx); \
        ALLOCATE_BUILTIN(chroma_i420_yuy2_mmx); \
        ALLOCATE_BUILTIN(chroma_i422_yuy2_mmx); \
        ALLOCATE_BUILTIN(chroma_i420_ymga_mmx); \
        ALLOCATE_BUILTIN(memcpymmxext); \
        ALLOCATE_BUILTIN(idctmmxext); \
        ALLOCATE_BUILTIN(motionmmxext); \
        ALLOCATE_BUILTIN(memcpy3dn); \
        ALLOCATE_BUILTIN(imdct3dn); \
        ALLOCATE_BUILTIN(downmix3dn); \
        ALLOCATE_BUILTIN(imdctsse); \
        ALLOCATE_BUILTIN(downmixsse); \
        ALLOCATE_BUILTIN(ffmpeg); \
        ALLOCATE_BUILTIN(a52); \
    } while( 0 );

